local EXP = {
	Event = {},
	data = {
		playerID = "",
		reallevel = nil,
		update = false,
		meter_x = 0,
		meter_y = 0,
		startEXP=0,
		sessionStart =0,
		gainedEXP = nil,
		lastkill = 1,
		levelneedschecked = true,
		enable = false,
		
	},
	 
}
-- start frames
local main = UI.CreateContext("UI")
local box = UI.CreateFrame("Frame", "box", main)
local ticker = UI.CreateFrame("Text", "Ticker", box)
local icon = UI.CreateFrame("Texture", "Icon", main)

local ticker2 = UI.CreateFrame("Text", "Ticker2", box)
local icon2 = UI.CreateFrame("Texture", "Icon2", main)


box:SetPoint("TOPLEFT",UIParent,"TOPLEFT",100,100)
box:SetWidth(155)
box:SetHeight(60)
box:SetAlpha(.6)
box:SetVisible(true)
box:SetBackgroundColor(0,0,0)
box:SetLayer(1)

ticker:SetText("No Data")
ticker:SetPoint("TOPRIGHT",box,"TOPRIGHT",0,0)
ticker:SetFontSize(20)
ticker:SetLayer(2)

icon:SetPoint("TOPLEFT",box,"TOPLEFT",0,0)
icon:SetWidth(25)
icon:SetHeight(25)
icon:SetAlpha(1)
icon:SetVisible(true)
icon:SetTexture("Expedia", "time.PNG")
icon:SetLayer(2)



ticker2:SetText("No Data")
ticker2:SetPoint("TOPRIGHT",box,"TOPRIGHT",0,28)
ticker2:SetFontSize(20)
ticker2:SetLayer(2)

icon2:SetPoint("TOPLEFT",box,"TOPLEFT",0,28)
icon2:SetWidth(25)
icon2:SetHeight(25)
icon2:SetAlpha(1)
icon2:SetVisible(true)
icon2:SetTexture("Expedia", "kill.PNG")
icon2:SetLayer(2)


local function levelcheck()

if EXP.data.reallevel == nil then EXP.data.reallevel = Inspect.Unit.Detail("player").level end
if EXP.data.enable and EXP.data.levelneedschecked then
		if (Inspect.Unit.Detail("player").level)  == 60  then 
		main:SetVisible(false)
	--icon:SetVisible(false)
	--icon2:SetVisible(false)		
		print( "Expedia hidden due to max level character")
		EXP.data.update = false
		else main:SetVisible(true)
		EXP.data.update = true

		end
		
		EXP.data.levelneedschecked = false

end
end

local function unitAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		EXP.data.enable = true
		levelcheck()
		end 
		end 
		end
		
local function unitNotAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		EXP.data.enable = false
		end 
		end 
		end

function EXP.Event.LoadEnd(handle, identifier)
	if identifier == "Expedia" then
		
		EXP.data.playerID = Inspect.Unit.Lookup("player")
		EXP.data.sessionStart = Inspect.Time.Real()
		EXP.data.startEXP = nil
		EXP.data.levelneedschecked = true
		
		
		print("Expedia loaded. /EXP")
		
	end
end


function EXP.Event.SlashHandler(handle, str)
	
	local cmd, arg = string.match(str, "(%a+) ?(.*)")

		print("Slash Commands:")
		
	end
	

local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	EXP.data.meter_x = x - self.originalXDiff
	EXP.data.meter_y = y - self.originalYDiff
  end
end




local lastCall = Inspect.Time.Real()

--local getexp = Inspect.Experience()
--result = Inspect.Experience()
--accumulated	Experience accumulated so far in this character level.
--needed	Quantity of experience needed to gain a level.
--rested	Quantity of available rested experience.


local function EXPfade(handle)



if EXP.data.update and EXP.data.enable then

local now = Inspect.Time.Real()
	if (now<lastCall+1.2) then 
		return
	end
	
--if (Inspect.Unit.Detail("player").level) == ( 60 or nil) then return end

if EXP.data.startEXP == nil then EXP.data.startEXP = Inspect.Experience().accumulated return end

if EXP.data.sessionStart == nil then EXP.data.sessionStart = Inspect.Time.Real() return end

	
local sessionLen = (now - EXP.data.sessionStart)
local nowEXP = Inspect.Experience().accumulated
if nowEXP == nil then return end

-- trim data
if sessionLen > 1200 then

--halve exp gain
EXP.data.startEXP = EXP.data.startEXP + ((nowEXP - EXP.data.startEXP)/2)
--halve time passed
EXP.data.sessionStart = EXP.data.sessionStart + ((now - EXP.data.sessionStart)/2)

--recalc session length
sessionLen = (now - EXP.data.sessionStart)

end



local income = (nowEXP - EXP.data.startEXP) / sessionLen

--convert sec to time format
local nSeconds = (Inspect.Experience().needed - Inspect.Experience().accumulated) / income
local nHours =0
local nMins =0
local nSecs =0

if nSeconds ~= 0 then

nHours = string.format("%02.f", math.floor(nSeconds/3600));
nMins = string.format("%02.f", math.floor(nSeconds/60 - (nHours*60)));
nSecs = string.format("%02.f", math.floor(nSeconds - nHours*3600 - nMins *60));

end

--return nHours..":"..nMins..":"..nSecs




--test
--ticker:SetText(tostring(math.floor(sessionLen)))
--ticker2:SetText(tostring(math.floor(income)))
ticker:SetText(nHours..":"..nMins..":"..nSecs)

if (nHours == "nan" or nMins == "nan" or nSecs == "nan") then 
ticker:SetText("No Data")
end


lastCall = now

end
end



local function EXPkiller(handle)
if EXP.data.enable and EXP.data.update then

if EXP.data.startEXP == nil then EXP.data.startEXP = Inspect.Experience().accumulated end

if EXP.data.gainedEXP == nil then EXP.data.gainedEXP = EXP.data.startEXP end

local deltaEXP = Inspect.Experience().accumulated - EXP.data.gainedEXP

--ticker2:SetText(tostring(deltaEXP))
--
ticker2:SetText(tostring(math.ceil((Inspect.Experience().needed-Inspect.Experience().accumulated)/deltaEXP)))

EXP.data.gainedEXP = Inspect.Experience().accumulated
end
end

local function EXPding(handle, units)
if units[EXP.data.playerID] then
if EXP.data.update and EXP.data.enable then

if EXP.data.reallevel == nil then return end

if Inspect.Unit.Detail("player").level > EXP.data.reallevel then
EXP.data.levelneedschecked = true
levelcheck()
EXP.data.reallevel = Inspect.Unit.Detail("player").level



EXP.data.startEXP = Inspect.Experience().accumulated
EXP.data.gainedEXP = Inspect.Experience().accumulated
lastCall = Inspect.Time.Real()
EXP.data.sessionStart = Inspect.Time.Real()


ticker:SetText("DING!")
ticker2:SetText("GRATS!")

end
end
end
end


local function EXPsave(handle)
 	 
EXPmeter_x = EXP.data.meter_x
EXPmeter_y = EXP.data.meter_y

   end


local function EXPload(handle)

if EXPmeter_x then
EXP.data.meter_x = tonumber(EXPmeter_x)
end

if EXPmeter_y then
 EXP.data.meter_y = tonumber(EXPmeter_y)
 end


--EXPfade()
box:ClearAll()
box:SetPoint("TOPLEFT", main, "TOPLEFT", EXP.data.meter_x, EXP.data.meter_y)
box:SetWidth(140)
box:SetHeight(60)



   end
	
	AddDragFrame(box)
	

--table.insert(Event.System.Update.Begin, {fade, "Expedia", "fade"})
--table.insert(Event.Experience.Accumulated, {killer, "Expedia", "killer"})

--table.insert(Event.Unit.Detail.Level, {ding, "Expedia", "ding"})

--table.insert(Event.Addon.SavedVariables.Save.Begin, {EXPsave, "Expedia", "Save variables"})
--table.insert(Event.Addon.SavedVariables.Load.End, {EXPload, "Expedia", "Load variables"})
--table.insert(Event.Addon.Load.End, 				{EXP.Event.LoadEnd, 			"Expedia", "Init"})
--table.insert(Command.Slash.Register("EXP"), 		{EXP.Event.SlashHandler, 	"Expedia", "Slash"})

--2.5 prep
Command.Event.Attach(Event.Unit.Availability.Full, unitAvailable, "unitAvailable")
Command.Event.Attach(Event.Unit.Availability.None, unitNotAvailable, "unitNotAvailable")
Command.Event.Attach(Event.Unit.Availability.Partial, unitNotAvailable, "unitNotAvailable")

Command.Event.Attach(Event.System.Update.Begin, EXPfade, "fade")
Command.Event.Attach(Event.Experience.Accumulated, EXPkiller, "killer")

Command.Event.Attach(Event.Unit.Detail.Level, EXPding, "ding")

Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, EXPsave, "Save variables")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, EXPload, "Load variables")
Command.Event.Attach(Event.Addon.Load.End, EXP.Event.LoadEnd, "Init")
Command.Event.Attach(Command.Slash.Register("EXP"), EXP.Event.SlashHandler, "Slash")


